
%PROGETTO.M  file di supporto per il progetto di un algoritmo di controllo
%            nel piano w secondo le specifiche del file sintesi_es.pdf
%     
%Autore:      Ing. Federica Pascucci
%Data:        20/01/2005
%Versione:    0.1


%Chiudo tutte le finestre e cancello le variabili del Workspace
close all
clear all
%-------------------------------------------------------------------------%
%                Esempio di progetto per discretizzazione                 %
%-------------------------------------------------------------------------%


% Calcolo il guadagno del compensatore a regime
Kc = (1-0.09)/0.09;

% Inizializzo l'oggetto Matlab che descrive la funzione ad anello aperto
% tempo continuo
P1=tf([400*Kc],[1 20 400]);

% Definisco il tempo di campionamento
Ws=3000;
T=(2*pi)/Ws;

% Discretizzo il processo con il metodo dell'invarianza della risposta al
% gradino
sysGz=c2d(P1,T,'zoh');

% Passo nel piano w con il metodo di Tustin (inverso da dis -> con )
sysGw=d2c(sysGz,'tustin');


%Calcolo la nuova pulsazione di attraversamento nel piano w
Wt=100;
Ome_t=(Ws/pi)*tan((Wt*pi)/Ws) 

% Traccio i diagrammi di Bode della funzione ad anello aperto
figure
margin(sysGw)


% Dopo aver calcolato i parametri della rete correttrice, secondo le
% specifiche, inizializzo l'oggetto Matlab che descrive la rete correttrice

tau=0.026;
m=4.7;
rete=tf([tau 1],[tau/m 1]);

% Traccio i diagrammi di Bode della rete correttrice
figure
margin(rete)
sys=sysGw*rete;

% Verifico il soddisfacimento delle specifiche
figure
margin(sys)

% Ritorno nel piano w con la trasformazione di Tustin
sysdT=c2d(rete,T,'tustin')    % Tustin


% Predispongo le variabili che saranno usate da Simulink per la simulazione
[num,den]=tfdata(P1,'v');
[numz,denz]=tfdata(sysdT,'v');

% Simulo il sistema con Simulink
open('sim_d');
sim('sim_d');